#include "mmc.h"
#include "lcd.h"
#include "types.h"

#ifndef LFN_SCROLLING
	#define NAMESIZE LINESIZE
#else
	#define NAMESIZE 64
#endif

struct fat_filedata_st {
	u32 len;
	u16 startcl;
#ifdef DIR_SUPPORT
    u32 dirsect;
#else
	u16 dirsect;
#endif
	u08 dirsectoffs;
	u08 entries; // LFN => entries > 1
#ifdef DIR_SUPPORT
	u08 attr;
#endif
#ifndef LFN_USEBUF
	u08 name[NAMESIZE];
#else
	u08 *name;
#endif
};

#define FILEMODE_CLOSED 0
#define FILEMODE_READ 1
#define FILEMODE_WRITE 2

#define ATTR_DIRECTORY 0x10

// functions
u08up fat_init();
void print_filename(u08up y);
void print_filesize(void);
void fat_count_files(void);
u08up fat_read_filedata(u08up nr);	// new file data in global struct
#ifndef KLINGER_VERSION
void fat_delete_file(void);
#endif
u08up fat_openfile(u08up mode, u08up nr);
u08up fat_closefile(void);
u08up fat_getnextsector_rd(void);
u08up fat_getnextsector_wr(void);
#ifdef DIR_SUPPORT
    boolup fat_enter_dir(void);
    boolup fat_leave_dir(void);
#endif
u32up cluster2sector(u16up c);
