#ifndef _MAIN_H_
#define _MAIN_H_

#ifdef BACKLIGHT
#define PORT_BL     PORTC
#define PIN_BL      (1<<6)
#define BL_ON PORT_BL |= PIN_BL
#define BL_OFF PORT_BL &= ~PIN_BL
#endif

// Buttons
#define KEY_PORT    PIND
#define KEY_PORT2   PINB

#if (defined(RC5) || defined(EXT_SPEEDSIG)) && !defined(LED_DISP)
#define KEY_MASK    0xf8
#define KEY_PLAY    0x80
#else
#define KEY_MASK    0x7c
#define KEY_PLAY    0x04
#endif
#define KEY_MASK2       0x03


#ifdef KEY_REPEAT
#define KEY_REP_TIME_INIT   80
#define KEY_REP_TIME        20
#ifdef USE_RTC
#define FAST_SCROLL        30
#endif
#ifdef RC5
#define KEY_REP_TIME_INIT_IR    5
#define KEY_REP_TIME_IR            1
#endif
#endif

#define KEY_REC     0x10
#define KEY_SHIFT   0x10
#define KEY_STOP    0x08
#ifdef SWITCH_NAV_DIR
#define KEY_NEXT    0x40
#define KEY_LAST    0x20
#else
#define KEY_NEXT    0x20
#define KEY_LAST    0x40
#endif
#ifdef KEY_LR_SWITCHED
#define KEY_LEFT    0x01
#define KEY_RIGHT   0x02
#else
#define KEY_LEFT    0x02
#define KEY_RIGHT    0x01
#endif

#define RC5_CODE_PLAY   0x35
#define RC5_CODE_STOP   0x36
#define RC5_CODE_REC    0x37
#define RC5_CODE_LEFT   0x32
#define RC5_CODE_RIGHT  0x34
#define RC5_CODE_NEXT   0x20
#define RC5_CODE_LAST   0x21
#define RC5_CODE_DELETE 0x31
#ifdef LYRICS
#define RC5_CODE_LYR 0x3c
#endif
#ifdef TRANSPOSE
#define RC5_CODE_TRANSPOSE_UP    0x3a
#define RC5_CODE_TRANSPOSE_DOWN  0x3b
#endif
#define RC5_CODE_MENU       0x1d
#define RC5_CODE_PLAYNEXT   0x29
#define RC5_CODE_PLAYLAST   0x22
#ifdef MIDI_MONITOR
#define RC5_CODE_MON    0x3E
#endif

#endif
