/*
 * 	Doku, siehe http://www.mikrocontroller.net/articles/AVR_FAT32
 *  Neuste Version: http://www.mikrocontroller.net/svnbrowser/avr-fat32/
 *	Autor: Daniel R.
 */

#ifndef _MMC_H_
#define _MMC_H_

#include <avr/io.h>
#include <avr/interrupt.h>
#include "types.h"

	extern uint8_t 		mmc_init(void);		// initialisiert die pins und geschwindigkeit
	extern uint8_t 		mmc_read_sector (uint32_t addr,uint8_t *Buffer);	// liest einen sektor mit adresse addr auf Buffer
	extern uint8_t 		mmc_write_sector (uint32_t addr,uint8_t *Buffer);	// schreibt einen sektor mit der adresse addr aus dem puffer Buffer, auf die karte
	extern uint8_t		mmc_multi_block_stop_read (void);						// stop kommando fuer multiblock read operation
	extern uint8_t		mmc_multi_block_stop_write (void);						// stop kommando fuer multiblock write operation
	extern uint8_t 		mmc_multi_block_start_read (uint32_t addr);	// hier wird das kommando um mehrer bloecke am stueck zu lesen gesendet. ab addr
	extern void 				mmc_multi_block_read_sector (uint8_t *Buffer);	// hiermit werden nacheinander die bloecke gelesen
	extern uint8_t 		mmc_multi_block_start_write (uint32_t addr);	// hier wird das kommando um mehrere bloecke am stueck zu schreiben gesendet, ab addr
	extern uint8_t		mmc_multi_block_write_sector (uint8_t *Buffer);	// hiermit werden nacheinander die bloecke geschrieben

// starts the hardware
void MMC_hw_init(void);
// starts up the MMC card
u08up MMC_init(void);

//void mmc_read_sector(u32up s, u08 *buf);
//void mmc_write_sector(u32up s, u08 *buf);
void mmc_load_start(u32up s);
u08up mmc_fetch_byte(void);
void mmc_write_start(u32up s);
void mmc_write_byte(u08up b);
void mmc_complete_read(void);
void mmc_complete_write(void);
void mmc_read_block(u08 *buf, u16up cnt);
void mmc_write_block(u08 *buf, u16up cnt);


#endif
